import Validator from "@/utils/validate.js"
import { register } from '@/apis/user.js'

function smsValidate() {
	const smsValidator = new Validator()
	const form = this.form
	smsValidator.add(form.phone, [{strategy: 'notEmpty', errorMsg: '手机号码不能为空'}, {strategy: 'isMobile', errorMsg: '手机号码格式不正确'}])
	smsValidator.add(form.smsCode, [{strategy: 'notEmpty', errorMsg: '验证码不能为空'}])
	return smsValidator.validate()
}

function accoutValidate() {
	const smsValidator = new Validator()
	const form = this.form
	smsValidator.add(form.phone, [{strategy: 'notEmpty', errorMsg: '手机号码不能为空'}, {strategy: 'isMobile', errorMsg: '手机号码格式不正确'}])
	smsValidator.add(form.password, [{strategy: 'notEmpty', errorMsg: '密码不能为空'}])
	return smsValidator.validate()
}

async function registerCommon(params) {
	try{
		const res = await register(params)
		console.log(res)
	}catch(e){
		this.$toast({title: e.msg || '程序错误'})
	}
}

export default {
	smsValidate,
	accoutValidate,
	registerCommon
}