import { cartCount } from "@/apis/carts.js"

const state = {
	cart_count: 0
}

const mutations = {
	SETCOUNT(state, count) {
		state.cart_count = count
	}
}

const actions = {
	setCount: async ({ commit }) => {
		const res = await cartCount()
		const count = res.res.count
		console.log('vuex actions success ==========================================')
		if(res.status && count > 0) {
			commit('SETCOUNT', count)
			uni.setTabBarBadge({
				index: 2,
				text: count > 99 ? '99+' : JSON.stringify(count)
			})
		} else {
			wx.removeTabBarBadge({index: 2})
		}
	}
}

export default {
    namespaced: true, 
    state,
	mutations,
	actions
}