const validate_strategies = {
    notEmpty: (value, errorMsg) => {
        if(!value) return errorMsg;
    },
    minLength: (value, len, errorMsg) => {
        if(value.length < len) return errorMsg;
    },
    isMobile: (value, errorMsg) => {
        if(!(/^1[3-9]\d{9}$/.test(value))) return errorMsg;;
    },
	isHttp: (value, errorMsg) => {
		if(!value.startsWith("http")) return errorMsg;
	}
}

class Validator {
    constructor() {
        this.cache =[];
    }

    // 添加规则
    add(el, rules) {
        for(let i = 0, rule; rule = rules[i ++];) {
            (rule => {
                let strategyArr = rule.strategy.split(':');
                let errorMsg = rule.errorMsg;
                this.cache.push(() => {
                    let strategy = strategyArr.shift();
                    strategyArr.unshift(el);
                    strategyArr.push(errorMsg);
                    return validate_strategies[strategy].apply(el, strategyArr);
                })
            })(rule)
        }
    } 

    // 校验
    validate() {
        for(let i = 0, validateFn; validateFn = this.cache[i++];) {
            let errorMsg = validateFn()
            if(errorMsg) return errorMsg
        }
    }
}

export default Validator
